<script>

import UserDataService from "@/services/UserDataService";

export default {
  name: "user-list",
  data() {
    return {
      users: [],
      currentUser: null,
      currentIndex: -1,
      input: "",
      userNotFound: false
    };
  },
  methods: {
    retrieveUsers() {
      UserDataService.getAll()
          .then(response => {
            this.users = response.data;
            console.log(response.data);
          })
          .catch(e => {
            console.log(e);
          });
    },

    refreshList() {
      this.retrieveUsers();
      this.currentUser = null;
      this.currentIndex = -1;
      this.userNotFound = false;
      this.input = '';
    },

    setActiveUser(user, index) {
      this.currentUser = user;
      this.currentIndex = user ? index : -1;
    },

    removeAllUsers() {
      UserDataService.deleteAll()
          .then(response => {
            console.log(response.data);
            this.refreshList();
          })
          .catch(e => {
            console.log(e);
          });
    },
    searchName() {
      // this.userNotFound = true;
      UserDataService.findByName(this.input)
          .then(response => {
            if (response.status !== 200){
              this.userNotFound = true;
              const emptyDataError = new Error(response.statusText);
              emptyDataError.statusCode = response.status;
              throw emptyDataError;
            } else {
              this.users = [];
              // this.users = response.data; // It displays an empty table
              this.users.push(response.data);
              this.setActiveUser(null);
              console.log(this.users);
            }
          })
          .catch(e => {
            this.userNotFound = true;
            console.log(e);
          });
    }
  },
  mounted() {
    this.retrieveUsers();
  }
};
</script>

<template>
  <div class="list row">
    <div class="col-md-8">
      <div class="input-group mb-3">
        <input type="text" class="form-control" placeholder="Search by name" v-model="input"/>
        <div class="input-group-append">
          <button class="btn btn-outline-secondary" type="button"
                  @click="searchName" >
            Search
          </button>
        </div>
      </div>
    </div>
    <div class="col-md-6">
      <div v-if="!userNotFound">
        <h4>User List</h4>
        <ul class="list-group">
          <li class="list-group-item"
              :class="{ active: index === currentIndex }"
              v-for="(user, index) in users"
              :key="index"
              @click="setActiveUser(user, index)"
          >
            {{ user.name }}
          </li>
        </ul>
      </div>

      <div v-else>
        <p>No data was found!</p>
      </div>
      <button class="m-3 btn btn-sm btn-info" @click="refreshList">
        Refresh
      </button>
      <button class="m-3 btn btn-sm btn-success" @click="$router.push('/add')">
        Add
      </button>
      <button class="m-3 btn btn-sm btn-danger" @click="removeAllUsers">
        Remove All
      </button>
    </div>
    <div class="col-md-6">
      <div v-if="currentUser">
        <h4>User</h4>
        <div>
          <label><strong>Uid:</strong></label> {{ currentUser.uid }}
        </div>
        <div>
          <label><strong>Name:</strong></label> {{ currentUser.name }}
        </div>
        <div>
          <label><strong>E-Mail:</strong></label> {{ currentUser.email }}
        </div>

<!--        <router-link :to="'/nutzers/' + currentUser.uid" class="badge badge-warning">Edit</router-link>-->
        <router-link
            :to="'/users/' + currentUser.uid"
            custom
            v-slot="{ navigate }"
       >
          <button
              class="m-3 btn btn-sm btn-warning"
              @click="navigate"
              role="link"
          >
          Edit
          </button>
        </router-link>
      </div>
      <div v-else>
        <br />
        <p>Please click on a User...</p>
      </div>
    </div>
  </div>
</template>

<style>
.list {
  text-align: left;
  max-width: 750px;
  margin: auto;
}
</style>